#ifndef lint
static char	*RCSid = "$Id$";
#endif

/*
 * name.c - handle note naming requests made by the user.
 *
 * Michael J. Hammel
 * Contractor
 * 1150 Inca St. TH 70
 * Denver, CO 80204
 * mjhammel@csn.org
 *
 * $Log$
 */

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Text.h>
#include <X11/Shell.h>
#include <stdio.h>

#include "xpostit.h"

Widget				dialogwidget;
Widget				namewidget;

/*
 * NameIt - put up a window prompt for the notes name
 */
void
NameIt(confirm_callbacks, cancel_callbacks)
XtCallbackRec *confirm_callbacks, *cancel_callbacks;
{
	Arg 					args[4];
	Window 				root, child;
	unsigned int 		buttons;
	register int 		nargs, nwidgets;
	static Boolean 	inited = False;
	static Widget 		widgets[3];
	int 					root_x, root_y, child_x, child_y;

	/*
	 * Find out where the mouse is, so we can put the confirmation
	 * box right there.
	 */
	XQueryPointer(display, XtWindow(toplevel), &root, &child,
		      &root_x, &root_y, &child_x, &child_y, &buttons);

	/*
	 * If we need to construct the confirmation box do that,
	 * otherwise just reset the position and callbacks and
	 * put it up again.
	 */
	if (!inited) {
		nargs = 0;
		SetArg(XtNx, root_x);
		SetArg(XtNy, root_y);

		/*
		 * The confirmation box will be a pop-up widget.
		 */
		namewidget = XtCreatePopupShell("Name",
						   transientShellWidgetClass,
						   toplevel, args, nargs);

		/*
		 * Make a dialog to put the buttons in.
		 */
		nargs = 0;
		SetArg(XtNlabel, PostItNoteDialog);
		SetArg(XtNvalue, "");
		SetArg(XtNresize, XawtextResizeWidth);
		dialogwidget = XtCreateManagedWidget("Dialog", dialogWidgetClass,
				      namewidget, args, nargs);

		nwidgets = -1;

		/*
		 * Confirmation button.
		 */
		nargs = 0;
		SetArg(XtNcallback, confirm_callbacks);
		widgets[++nwidgets] = XtCreateWidget("Confirm",
						     commandWidgetClass,
						     dialogwidget, args, nargs);

		/*
		 * Cancellation button.
		 */
		nargs = 0;
		SetArg(XtNcallback, cancel_callbacks);
		SetArg(XtNfromHoriz, widgets[nwidgets]);
		widgets[++nwidgets] = XtCreateWidget("Cancel",
						     commandWidgetClass,
						     dialogwidget, args, nargs);

		/*
		 * Let the shell widget know we're here.
		 */
		XtManageChildren(widgets, XtNumber(widgets));

		/* XtRealizeWidget(namewidget); */
		inited = True;
	}
	else {
		/*
		 * Reset the confirmation box position.
		 */
		nargs = 0;
		SetArg(XtNx, root_x);
		SetArg(XtNy, root_y);
		XtSetValues(namewidget, args, nargs);

		/* clear the dialog text */
		nargs = 0;
		SetArg(XtNvalue, "");
		XtSetValues(dialogwidget, args, nargs);

		/*
		 * Reset the callbacks.
		 */
		nargs = 0;
		SetArg(XtNcallback, confirm_callbacks);
		XtSetValues(widgets[0], args, nargs);

		nargs = 0;
		SetArg(XtNcallback, cancel_callbacks);
		XtSetValues(widgets[1], args, nargs);

	}

	/*
	 * Pop up the confirmation box.
	 */
	XtPopup(namewidget, XtGrabNonexclusive);
}

/*
 * ClearName - get rid of the confirmation box.
 */
void
ClearName()
{
	XtPopdown(namewidget);
}
