.TH XPOSTIT 1 "01 March 1995" SRI/X11R4
.SH NAME
xpostit \- X window system Post-it(r) notes
.SH SYNOPSIS
.B xpostit
[
.I \-toolkitoptions ...
] [
.I \-options ...
]
.SH DESCRIPTION
.I Xpostit
provides a mechanism for manipulating on-screen Post-it(r) notes.
All six sizes of Post-it notes may be displayed,
edited,
and saved to disk files.
In addition,
any on-screen note may be resized to any arbitrary size either when it is
created or at a later time.
.PP
All notes can be "hidden" - the notes are still available but not
shown on the screen until requested by the user.  Hidden notes will
stay hidden when xpostit is exited and then restarted (as long as
the user saves all notes before exiting).
.PP
When
.I xpostit
is first invoked,
it creates a small window with a plaid background.
This is the control window for
.IR xpostit .
Additionally,
if any notes were stored in the save directory (see below),
these will be placed on the screen at their last locations,
unless they were hidden when saved (see below).
Each Post-it note,
when created,
makes another window on the screen.
.I Xpostit
is controlled using the mouse buttons and a menu.
The Post-it notes are controlled by using a drop down menu.
.SH OPTIONS
.PP
.I Xpostit
accepts all of the standard X Toolkit command line options along with the
additional options listed below.
.TP 8
.BI \-bs " number"
Specifies the size of the character buffer in which to save each Post-it
note.
A note may not contain more than this number of characters,
including newlines.
The default is 1024.
.TP 8
.BI \-dir " path"
Specifies the path name of the directory in which to store saved Post-it notes.
If
.I path
begins with a `/' it is taken as-is;
if it does not begin with a `/',
the path is taken relative to the home directory.
If the named directory does not already exist, then
.I xpostit
attempts to create it.
The default is
.IR \&.postitnotes .
.TP 8
.B \-sb
Enables scroll-bars.
If specified,
a scroll bar will be attached to each Post-it note.
.TP 8
.B \-sv
Enables save-on-exit.
When specified,
this option tells
.I xpostit
to save all Post-it notes to disk files when exiting.
If not specified,
notes will only be saved to disk files when saved manually by the user.
It is useful to specify this option since hidden notes cannot be saved
as hidden notes unless either the "Save All Notes" option is used or Save
on Exit (-sv) has been specified on the command line.
.SH "WIDGET USAGE"
.PP
.I Xpostit
uses several widget types to construct the objects it uses.
.PP
The control window is a Plaid widget called ``Plaid''.
This is a widget designed by David A. Curry, the original author of
.I xpostit.
.PP
The menu is a pop-up shell called ``Menu'' containing a SimpleMenu widget.
From this menu the hidden notes menu can be popped up.  The hidden notes
menu is also a SimpleMenu widget.
.PP
Each Post-it note is a pop-up shell called ``PostItNote'',
containing a Form widget called ``Note''
which contains a Text widget called ``NoteText'',
and a MenuButton widget called "Options".  The Options button, when
selected, pops up a drop-down menu called "OptionsMenu" (see the Xpostit.ad
application defaults file).  Inside of this menu are 
five menu items called ``Save'', ``Erase'', ``Destroy'',
``Hide'', and ``Name''.
.PP
The confirmation box is a pop-up shell called ``Confirm'',
containing a Form widget called ``Buttons''
which contains two Command widgets called ``Confirm'' and ``Cancel''.
There is also dialog box which pops up when the Name menu item 
is selected which is called "Dialog".
.SH "RESOURCES"
.PP
.I Xpostit
understands all of the core X Toolkit resource names and classes as well
as those listed below,
which are all of class
.BR Xpostit .
.TP 8
.B \&.bufSize
Specifies the size of the character buffer used to store a Post-it note.
The default is 1024.
.TP 8
.B \&.noteDir
Specifies the path name of the directory in which to store saved notes.
The default is
.IR \&.postitnotes .
.TP 8
.B \&.saveNotes
Controls the state of the save-on-exit option.
The default is
.BR false .
.TP 8
.B \&.scrollBar
Controls placing scroll bars on Post-it notes.
The default is
.BR false .
.SH "ACTIONS"
.PP
It is possible to rebind the mouse buttons in the Plaid widget to perform
different functions by changing the widget's translations.  It is not
recommended that other actions (as specified in the application defaults
file) be changed, however.
The
.I raise()
action,
normally bound to the left mouse button,
raises all notes.
The
.I lower()
action,
normally bound to the middle mouse button,
lowers all notes.
The menu raising function,
normally bound to the right mouse button,
is performed by calling the actions
.I "XawPositionSimpleMenu(Menu)"
and
.IR "MenuPopup(Menu)" .
.SH "THE CONTROL WINDOW"
.PP
.I Xpostit
allows three operations to be performed from its control window.
Pressing the left mouse button in the control window will cause all Post-it
notes on the screen to be raised to the top.
Pressing the middle mouse button in the control window will cause all Post-it
notes on the screen to be lowered to the bottom.
Pressing the right mouse button in the control window raises the
.I xpostit
menu.
.SH "THE PLAID MENU"
.PP
The
.I xpostit
plaid menu provides the following selections:
.TP 8
.B "Create 1.5x2 Note"
Create a new Post-it note,
1.5 inches tall by 2 inches wide.
The window will normally need to be positioned using the window manager.
.TP 8
.B "Create 2x3 Note"
Create a new Post-it note,
2 inches tall by 3 inches wide.
.TP 8
.B "Create 3x3 Note"
Create a new Post-it note,
3 inches square.
.TP 8
.B "Create 3x4 Note"
Create a new Post-it note,
3 inches tall by 4 inches wide.
.TP 8
.B "Create 3x5 Note"
Create a new Post-it note,
3 inches tall by 5 inches wide.
.TP 8
.B "Create 4x6 Note"
Create a new Post-it note,
4 inches tall by 6 inches wide.
.TP 8
.B "Raise All Notes"
Raise all Post-it notes to the top.
This is equivalent to pressing the left mouse button in the control window.
.TP 8
.B "Lower All Notes"
Lower all Post-it notes to the bottom.
This is equivalent to pressing the middle mouse button in the control window.
.TP 8
.B "Save All Notes"
Save all Post-it notes to disk files in the save directory.
.TP 8
.B "Hidden Notes"
Pops up another menu which lists all the notes that are currently hidden.
The list contains the names of the notes so it is wise to give a note
a meaningful name (using the Name option from the pull-down menu of each
note) before it is hidden.
.TP 8
.B Exit
Exit
.I xpostit.
If the
.B \-sv
command line option was given,
or the
.B saveNotes
resource is
.B true,
all Post-it notes will be saved to disk first.
.PP
To select an item from the menu,
drag the mouse cursor to that item and release the mouse button.
.SH "THE HIDDEN NOTES MENU"
.PP
This menu pops up from the ``Hidden Notes'' option of the plaid menu.  It
functions the same as the plaid menu except the menu does not disappear
until either a menu option is selected or the label (at the top of the
menu)
is clicked on.
.SH "THE POST-IT NOTE"
.PP
Each Post-it note is made up of three parts (plus an optional scroll bar):
a Title bar,
a text window where the text of the note is stored,
and an Options pull-down menu.
.PP
To enter text into a Post-it note,
simply move the mouse cursor into the text window and start typing.
Since the text window is actually a Text widget,
all the Text widget translations are accepted.
Essentially,
this means you can use most of the \s-1EMACS\s0 control keys in the window.
Additionally,
the various mouse buttons used for manipulating the selections and cut
buffer are understood.
.PP
After entering text in the Post-it note,
you may wish to save the note in a disk file.
This way,
if the machine goes down,
or if you exit
.IR xpostit ,
the Post-it note can be restored when you restart
.IR xpostit .
(Post-it notes are also saved automatically (if
.B saveNotes
is true) if a SIGHUP,
SIGINT,
SIGTERM,
or SIGQUIT signal is received.)
To save the note to a disk file,
click on the Options button and
drag the mouse cursor to the menu item labeled ``Save'', then release the
mouse button.
The note will be saved as the file ``note\fIn\fP'' in your save directory,
where
.I n
is some sequence number.
Note that the ``Save'' menu item will not allow you to save unless
something have been typed in the Text of the note, the name of the note
has been changed, or the text of the note has been erased.
This is a good way for
checking if you've made changes to the note.  If the Save menu item is
"insensitive" (grayed-out) then you haven't made any changes to the Text
of the note.
.BR \s-1NOTE\s0 :
it is important to remember that until you have pressed the ``Save'' button,
any changed data in the Post-it note is not saved on disk and can be lost if
the system goes down or
.I xpostit
exits.
.PP
To erase the entire contents of the text window,
you can 
click on the Options button and select the ``Erase'' menu item.
This will bring up a confirmation window,
which has two buttons labeled ``Confirm'' and ``Cancel''.
If you press the ``Confirm'' button,
the text will be erased.
If you press the ``Cancel'' button,
the operation is canceled,
and nothing will happen.
.BR \s-1NOTE\s0 :
erasing the text in the window does not affect any contents of the note
you have saved on disk unless you press the ``Save'' button again.
.PP
To destroy a Post-it note,
getting rid of its window on the screen and the disk file it is saved in,
click on the Options button and select the ``Destroy'' menu item.
This will bring up a confirmation window as described above.
If you confirm the operation,
the Post-it note will disappear from the screen and the disk file it was
saved in will be deleted.
.PP
To rename a note,
you can 
click on the Options button and select the ``Name'' menu item.
This will bring up a dialog box,
which has two buttons labeled ``Confirm'' and ``Cancel'' as well
as a field to enter text for the new name.
If you press the ``Confirm'' button,
the new name will be placed in the title bar of the note.
If you press the ``Cancel'' button,
the operation is canceled.
.PP
To hide a note,
you can 
click on the Options button and select the ``Hide'' menu item.
This will cause the note to disappear from the screen.  To bring the note
back, select the ``Hidden Notes'' option from the plaid pull-down menu.
Then select the note you wish to bring back up.
.BR \s-1NOTE\s0 :
The hidden notes will not stay hidden between
.IR xpostit
sessions unless you first select the "Save All Notes" option from the plaid
menu or options to save on exit (see discussion above) have been set.
.SH "SEE ALSO"
X(1)
.SH BUGS
.PP
The sizes of the Post-it notes are only as accurate as the display
dimension and resolution returned by the server.
On the Sun server and possibly others,
this means they aren't all that accurate.
.PP
On Linux systems the word wrap feature of the Text Widget appears broken.
The words get wrapped to the next line but they do not get erased from the
previous line.  I'm not sure how to fix this.
.PP
There is a Warning that writes to stdout regarding a null child being
managed.  I've seen it periodically but not consistantly, so I'm not sure
whats causing it.  I do know that it doesn't appear to cause any functional
problems.  So the heck with it.
.PP
The Dialog used to name a note doesn't limit the number of characters that
can be used in a name, although it does prevent (by use of translations)
a user from putting a newline in the text.  The drawback to not limiting
the length of the name is that the dialog box's text field won't resize or
scroll to the right as characters are typed off the right hand edge of the
field.  Bummer dude.
.PP
The Hidden Notes menu, if it has no entries, can be fairly small (with
only a title).  Since this menu doesn't go away unless you click on it, it
can get hidden under other windows running under a window manager which
uses autoraise.  You could probably change this with translations, but I
like having the menu stay up till I tell it to go away.  Under Linux and
fvwm, I have one desktop devoted to Post-It notes so I don't worry too much
about other windows hiding the menu.
.PP
Without a color display for canary yellow notes and red plaid,
the aesthetic value of
.I xpostit
cannot be fully appreciated.
.SH AUTHOR
Originally by David A. Curry, SRI International.
Name, Save (sensitivity), Hidden Notes, and changes to buttons (to make 
them menus) by Michael J. Hammel, currently not with anyone but actively
looking.
.sp
``Post-it'' and the plaid design are registered trademarks of 3M.
